import processing.core.*; 
import processing.xml.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class Staircase extends PApplet {

public void setup() 
{
  background(255);
  size(550, 550);
  stroke(0);
  smooth();
  noLoop();
}

int order=-1, x0=25, y0=25, l=500;

public void draw() 
  {
     background(255);
     stroke(0);
     quad(x0,y0,x0,y0+l,x0+l,y0+l,x0+l,y0);
     line(x0,y0,x0+l,y0+l);
     stroke(255,0,0);
     strokeWeight(2);
     drawStaircase(order,x0,y0,l);
     strokeWeight(1);
  }

public void drawStaircase(int order, int x, int y, int l)
  {
    if (order == 0)
      drawCorner(x,y,l);  
    else
      if (order>0)
      {
        drawStaircase(order-1,x,y,l/2);
        drawStaircase(order-1,x+l/2,y+l/2,l/2);
      }
   }

public void drawCorner(int x, int y, int l)
  {
    line(x,y,x,y+l);
    line(x,y+l,x+l,y+l);
  }
  
  public void mousePressed() 
  {
    redraw();
    order++;
    if (order==10)
      order=-1;
  }
  
  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#ECE9D8", "Staircase" });
  }
}
